import java.io.*;

public class Sample09
{
    public Sample09()
	{
	}
    public static void main(final String args[]) throws IOException
    {
	   byte [] dongleInfo = new byte [100];
	   int [] count = new int[1];
	   int [] handle = new int [1];
	   int nRet = 0;
	   
       Dongle dongle = new Dongle();	   
	   //ö
       nRet = dongle.Dongle_Enum(dongleInfo, count);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_Enum error. error code: 0x%08X .\n ", nRet);
		 return ;
	   }	   
	   System.out.printf("Enum Dongle ARM count: [%d] .\n", count[0]); 
	   
	   //򿪵һ
	   nRet = dongle.Dongle_Open(handle, 0);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_Open error. error code: 0x%08X .\n ", nRet);
		 return ;
	   }
	   System.out.printf("Open Dongle ARM success[handle=0x%08X]. \n",handle[0]);
	   
	   //֤
	   int []nRemain = new int[1];
       String strPin = "FFFFFFFFFFFFFFFF"; //ĬϿ
	   nRet = dongle.Dongle_VerifyPIN(handle[0], dongle.FLAG_ADMINPIN, strPin, nRemain);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_VerifyPIN error [remain cout: %d]. error code: 0x%08X .\n ", nRemain[0], nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Verify admin pin success. \n");
	   
	   //ECC˽Կ
	   byte [] prikeyLic  = new byte[1024];
	   int []prikeyLicLen = new int[1];
	   int callCount = 0xFFFFFFFF;//ô0xFFFFFFFFʾ
	   byte callPriv = 1;// СȨޣ0ΪСȨ  1ΪСûȨ  2ΪСȨ
	   byte isDecOnRAM = 0;//Ƿڼڴеݼ
	   byte isReset = 0;//ִ֮Ƿص̬
	   nRet = dongle.Convert_PRIKEY_LIC_To_Buffer(callCount, callPriv, isDecOnRAM, isReset, prikeyLic, prikeyLicLen);//Ȩ޽ṹ
	   System.out.printf("Convert_PRIKEY_LIC_To_Buffer return: 0x%08X [prikeyliclen=%d].\n", nRet, prikeyLicLen[0]);
	   short type = (short)Dongle.FILE_PRIKEY_ECCSM2;
	   short size = 256;//Ҳ192
	   byte [] attrBuffer = new byte[1024];
	   int [] attrBufferLen = new int[1];
	   nRet = dongle.Convert_PRIKEY_FILE_ATTR_To_Buffer(type, size, prikeyLic, prikeyLicLen[0], attrBuffer, attrBufferLen);//Խṹ
	   System.out.printf("Convert_PRIKEY_FILE_ATTR_To_Buffer return: 0x%08X [attrBufferLen=%d].\n", nRet, attrBufferLen[0]);	 
	   nRet = dongle.Dongle_CreateFile(handle[0], Dongle.FILE_PRIKEY_ECCSM2, 0x2222, attrBuffer);//ļ
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_CreateFile error . error code: 0x%08X .\n", nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Create ECC private key success. \n");
	   
	   //ECC˽Կ
	   byte [] eccPubkey = new byte[1024];
	   byte [] eccPrikey = new byte[1024];
	   int [] eccPubLen = new int[1];
	   int [] eccPriLen = new int [1];
	   nRet = dongle.Dongle_EccGenPubPriKey(handle[0], 0x2222, eccPubkey, eccPubLen, eccPrikey, eccPriLen);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_EccGenPubPriKey error . error code: 0x%08X .\n", nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Gen ECC public key and private key success. \n");
	   
	   //Կ˽Կдļȥ
	   FileOutputStream fos;
       fos = new FileOutputStream("2222.EccSm2pub");
       fos.write(eccPubkey, 0, eccPubLen[0]);
       fos.close();
	   
	   fos = new FileOutputStream("2222.EccSm2pri");
       fos.write(eccPrikey, 0, eccPriLen[0]);
       fos.close();
	   
	   //ECCǩǩ
	   //1ECCǩ
	   byte [] hashdata = new byte[32];//256ȵhash256/8=32192ȵhash192/8=24
	   byte [] outdata = new byte[64];//ǩݱΪ64
	   nRet = dongle.Dongle_GenRandom(handle[0], 32, hashdata);//ȡΪhashֵ
	   System.out.printf("Dongle_GenRandom as hash data return: 0x%08X .\n", nRet);
	   nRet = dongle.Dongle_EccSign(handle[0],0x2222,hashdata, 32, outdata);
	   System.out.printf("Dongle_EccSign return: 0x%08X .\n", nRet);
	   //2ECCǩ
	   nRet = dongle.Dongle_EccVerify(handle[0],eccPubkey,hashdata, 32, outdata);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_EccVerify error. error code: 0x%08X .\n", nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("ECC public key verify success. \n");
	   
	   //ɾECC˽Կļ
	   nRet = dongle.Dongle_DeleteFile(handle[0], Dongle.FILE_PRIKEY_ECCSM2, 0x2222);
       if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_DeleteFile error . error code: 0x%08X .\n", nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Delete ECC private key success. \n");	
	   
	   //رռ
	   nRet = dongle.Dongle_Close(handle[0]);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	      System.out.printf("Dongle_Close error. error code: 0x%08X \n", nRet);
		  return;
	   }
	   System.out.printf("Close Dongle ARM success. \n");
       	   
    }    
}