import java.io.*;
import java.io.IOException;

public class Sample08
{
    public Sample08()
	{
	}
    public static void main(final String args[]) throws IOException
    {
	   byte [] dongleInfo = new byte [100];
	   int [] count = new int[1];
	   int [] handle = new int [1];
	   int nRet = 0;
	   int i = 0;
	   
       Dongle dongle = new Dongle();	   
	   //ö
       nRet = dongle.Dongle_Enum(dongleInfo, count);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_Enum error. error code: 0x%08X .\n ", nRet);
		 return ;
	   }	   
	   System.out.printf("Enum Dongle ARM count: [%d] .\n", count[0]); 
	   
	   //򿪵һ
	   nRet = dongle.Dongle_Open(handle, 0);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_Open error. error code: 0x%08X .\n ", nRet);
		 return ;
	   }
	   System.out.printf("Open Dongle ARM success[handle=0x%08X]. \n",handle[0]);
	   
	   //֤
	   int []nRemain = new int[1];
       String strPin = "FFFFFFFFFFFFFFFF"; //ĬϿ
	   nRet = dongle.Dongle_VerifyPIN(handle[0], dongle.FLAG_ADMINPIN, strPin, nRemain);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_VerifyPIN error [remain cout: %d]. error code: 0x%08X .\n ", nRemain[0], nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Verify admin pin success. \n");
	   
	   //RSA˽Կ
	   byte [] prikeyLic  = new byte[1024];
	   int []prikeyLicLen = new int[1];
	   int callCount = 0xFFFFFFFF;//ô0xFFFFFFFFʾ
	   byte callPriv = 1;// СȨޣ0ΪСȨ  1ΪСûȨ  2ΪСȨ
	   byte isDecOnRAM = 0;//Ƿڼڴеݼ
	   byte isReset = 0;//ִ֮Ƿص̬
	   nRet = dongle.Convert_PRIKEY_LIC_To_Buffer(callCount, callPriv, isDecOnRAM, isReset, prikeyLic, prikeyLicLen);//Ȩ޽ṹ
	   System.out.printf("Convert_PRIKEY_LIC_To_Buffer return: 0x%08X [prikeyliclen=%d].\n", nRet, prikeyLicLen[0]);
	   short type = (short)Dongle.FILE_PRIKEY_RSA;
	   short size = 1024;//˴Ҳ2048
	   byte [] attrBuffer = new byte[1024];
	   int [] attrBufferLen = new int[1];
	   nRet = dongle.Convert_PRIKEY_FILE_ATTR_To_Buffer(type, size, prikeyLic, prikeyLicLen[0], attrBuffer, attrBufferLen);//Խṹ
	   System.out.printf("Convert_PRIKEY_FILE_ATTR_To_Buffer return: 0x%08X [attrBufferLen=%d].\n", nRet, attrBufferLen[0]);	 
	   nRet = dongle.Dongle_CreateFile(handle[0], Dongle.FILE_PRIKEY_RSA, 0x1111, attrBuffer);//ļ
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_CreateFile error . error code: 0x%08X .\n", nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Create RSA private key success. \n");
	   
	   //RSAԿ˽Կ
	   byte [] rsaPubkey = new byte[1024];
	   byte [] rsaPrikey = new byte[1024];
	   int []rsaPubLen = new int[1];
	   int []rsaPriLen = new int [1];
	   nRet = dongle.Dongle_RsaGenPubPriKey(handle[0], 0x1111, rsaPubkey, rsaPubLen, rsaPrikey, rsaPriLen);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_RsaGenPubPriKey error . error code: 0x%08X .\n", nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Gen RSA public key and private key success. \n");
	   
	   //Կ˽Կдļȥ
	   FileOutputStream fos;
       fos = new FileOutputStream("1111.Rsapub");
       fos.write(rsaPubkey, 0, rsaPubLen[0]);
       fos.close();
	   
	   fos = new FileOutputStream("1111.Rsapri");
       fos.write(rsaPrikey, 0, rsaPriLen[0]);
       fos.close();
	   
	   //RSAмӽ
	   //RSA˽ԿܹԿ
	   //ݳÿֻԿ(1024/8 - 11 = 1172048/8 -11 = 245)
	   byte [] m = new byte[117];
	   byte [] temp = new byte[117];
	   //ܳݳΪ 1024/8 = 128  2048/8 = 256
	   byte [] c = new byte[128];
	   int []outLen = new int[1];
	   outLen[0] = 128;
	   for(i = 0; i < 117; i++) m[i] = temp[i] = (byte)i;
	   //1.˽Կ
	   nRet = dongle.Dongle_RsaPri(handle[0],0x1111,Dongle.FLAG_ENCODE,m,117,c,outLen);
	   
	   for(i = 0; i < 117; i++) m[i] = (byte)0;
	   int []outLen2 = new int[1];
	   outLen2[0] = 117;
	   //2.Կ
	   nRet = dongle.Dongle_RsaPub(handle[0],Dongle.FLAG_DECODE,rsaPubkey,c,outLen[0],m,outLen2);
	   
	   int isSame = 1;
	   for(i = 0; i < 117; i++)
	   { 
	      if(m[i] != temp[i])
		  {
		     isSame = 0;
			 break;
		  }
	   }
	   if(isSame == 1)
	     System.out.printf("RSA prikey encode and public decode is correct.\n");
	   else 
	     System.out.printf("RSA prikey encode and public decode is error.\n");
	 
	   //RSAԿ˽Կ
	   //1.Կ
	   for(i = 0; i < 117; i++) m[i] = temp[i] = (byte)i;
	   outLen[0] = 128;
	   nRet = dongle.Dongle_RsaPub(handle[0],Dongle.FLAG_ENCODE,rsaPubkey,m,117,m,outLen);
	   //2.˽Կ
	   outLen2[0] = 117;
	   nRet = dongle.Dongle_RsaPri(handle[0],0x1111,Dongle.FLAG_DECODE,m,outLen[0],m, outLen2);
	 
	   isSame = 1;
	   for(i = 0; i < 117; i++)
	   { 
	      if(m[i] != temp[i])
		  {
		    isSame = 0;
		    break;
		  }
	   }
	   if(isSame == 1)
	     System.out.printf("RSA public encode and prikey decode is correct.\n");
	   else
	     System.out.printf("RSA public encode and prikey decode is error.\n");
	   
	   //ɾRSA˽Կļ
	   nRet = dongle.Dongle_DeleteFile(handle[0], Dongle.FILE_PRIKEY_RSA, 0x1111);
       if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	     System.out.printf("Dongle_DeleteFile error . error code: 0x%08X .\n", nRet);
		 dongle.Dongle_Close(handle[0]);
		 return ;
	   }
	   System.out.printf("Delete RSA private key success. \n");	   
	   //رռ
	   nRet = dongle.Dongle_Close(handle[0]);
	   if(nRet != Dongle.DONGLE_SUCCESS)
	   {
	      System.out.printf("Dongle_Close error. error code: 0x%08X \n", nRet);
		  return;
	   }
	   System.out.printf("Close Dongle ARM success. \n");
       	   
    }    
}